<template>
    <Spinner v-if="loading"></Spinner>
    <template v-else>
        <VTable v-model:currentPage="currentPage" :data="computedData" :filters="filter" sortHeaderClass="flex items-center"
            class="w-full text-md text-left text-gray-500 dark:text-gray-300 border-t" :pageSize="10"
            @stateChanged="tableState = $event" @totalPagesChanged="totalPages = $event">
            <template #head class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400">
                <tr class="border-b">
                    <VTh sortKey="environmentId" defaultSort="desc" class="px-6 py-3">
                        Environment Id
                    </VTh>
                    <VTh sortKey="id" class="px-6 py-3">Id</VTh>
                    <th class="px-6 py-3">Free Resources</th>
                </tr>
            </template>
            <template #body="{ rows }">
                <tr v-for="row in rows" :key="row.id"
                    class="border-b dark:bg-gray-800 dark:border-gray-700 hover:bg-gray-700 hover:cursor-pointer">
                    <td class="px-6 py-2 font-medium text-gray-900 dark:text-white whitespace-nowrap">
                        {{ row.environmentId }}
                    </td>
                    <td class="px-6 py-2">
                        {{ row.id }}
                    </td>
                    <td class="px-6 py-2">
                        {{ row.resources }}
                    </td>
                </tr>
            </template>
        </VTable>
        <VTPagination v-model:currentPage="currentPage" :totalPages="totalPages" :boundaryLinks="true" v-if="totalPages > 1"
            class="w-full text-gray-700 mt-2 flex justify-center" />
    </template>
</template>

<style>
ul.pagination {
    display: flex;
    align-items: center;
}

ul.pagination>li {
    margin-right: 2px;
}
</style>

<script lang="ts" setup>
import { computed, ref } from "vue";

const props = defineProps(["tableData", "loading"]);
const computedData = computed(
    () =>
        props.tableData?.flatMap((environment: any) => {
            return environment.nodes?.map((node: any) => {
                const nodeInfo = {
                    environmentId: environment.id,
                    id: node.id,
                    resources: `cpu: ${node.allocatable.cpu}/${node.capacity.cpu}; memory: ${toGi(
                        node.allocatable.memory
                    )}/${toGi(node.capacity.memory)}`,
                };

                return nodeInfo;
            });
        }) ?? []
);

const toGi = (value: string) => {
    const splitted = value.split("Ki");
    const valueGi = Number(splitted[0]) / 1024 / 1024;
    return `${valueGi.toFixed(2)}Gi`;
};

const currentPage = ref(1);
const totalPages = ref(0);

const filter = ref({
    default: {
        value: "",
        keys: ["environmentId", "id"],
    },
});

const tableState = ref();
</script>
